/*
 * iGeom by LInE
 * Free software to student private data
 *
 * http://www.matematica.br/igeom
 * http://www.usp.br/line
 *
 * ./app/core/drawers/drawer-aggregator.js
 * @version 2023/07/14: Fix in reading GEO file with midpoint
 */

export class DrawerAggregator {

  static static_id = 1; // help in debug

  constructor (drawer, geometricObject, konvaObject, elementClass) {
    try {
      //D if (DrawerAggregator.static_id == 1) { console.trace(); }
      this.id = DrawerAggregator.static_id++; // DrawerAggregator identification number
      //D console.log("drawer-aggregator.js!constructor(.): this.id=" + this.id); //D
      this.drawer = drawer;
      this.genericObject = geometricObject;
      this.konvaObject = konvaObject;
      this.aggregators = [];
      this.visible = true;
      if (elementClass != undefined) this.elementClass = elementClass;
      else {
        if (konvaObject.attrs != undefined && konvaObject.attrs.class != undefined)
          this.elementClass = konvaObject.attrs.class;
        }
    } catch (error) {
      console.log("drawer-aggregator.js!constructor(.): this.id=" + this.id + ", error = " + error);
      }
    //DD if (this.id==2) console.trace();
    console.log("drawer-aggregator.js!constructor(.): OK final de this.id=" + this.id); //D
    }

  setGeometricObject (genericObject) {
    this.genericObject = genericObject;
    }
  setDrawer (drawer) {
    this.drawer = drawer;
    }
  setKonvaObject (konvaObject) {
    this.konvaObject = konvaObject;
    }
  setElementClass (elementClass) {
    this.elementClass = elementClass;
    }

  addAggregator (aggregator) {
    if (this.aggregators==undefined) {
      console.log("drawer-aggregator.js!addAggregator(aggregator): Error, 'this.aggregators==undefined'");
      return;
      }
    var auxE = "1, ";
    try {
      if (!this.aggregators.includes(aggregator)) {
        auxE += "2, "; //D
        this.aggregators.push(aggregator);
        auxE += "3, "; //D
        this.genericObject.dependentsOnThis.push(aggregator.genericObject);
        }
    } catch (error) {
      console.log("drawer-aggregator.js!addAggregator(aggregator): Error '" + error + "', with " + auxE);
      }
    }

  update (e) {
    var tam = this.aggregators?this.aggregators.length:0; //D xxx
    var aux = JSON.stringify(this.geometricObject) + ", #this.aggregators=" + tam + " : "; //D xxx
    for (var ii=0; ii<tam; ii++) aux += this.aggregators[ii].id + ","; //D xxx
    console.log("drawer-aggregator.js!update(e): this.id=" + this.id + ": this.geometricObject=" + aux); //D xxx
    this.drawer.update(this, e);
    this.updateAggregators(this.aggregators, e);
      }

  updateAggregators (aggregators, e) {
    console.log("drawer-aggregator.js!updateAggregators(aggregators,e)"); //D
    aggregators.forEach(aggregator => {
      aggregator.drawer.update(aggregator, e);
      if (aggregator.aggregators == undefined || aggregator.aggregators.length == 0) {
        return;
        }
      this.updateAggregators(aggregator.aggregators, e);
      });
    }

  }